<?php

/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 

function getToken($thisLogin,$thisPassword) {

    require_once("/usr/share/bm-stats/www/class/bmAPI/bmAPI.php");

    $bmIni = '/etc/bm/bm.ini';
    $dataBmIni = parse_ini_file($bmIni);

    $baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/" ;

    /* A set of options used by the cURL client  */
    $option = array(
                            CURLOPT_VERBOSE        => FALSE,
                            CURLOPT_RETURNTRANSFER => TRUE,
                            CURLOPT_SSL_VERIFYPEER => FALSE,
                            CURLOPT_SSL_VERIFYHOST => 0,
                            CURLOPT_CONNECTTIMEOUT => 5,
                            CURLOPT_TIMEOUT        => 5,
                          );

    /* Get a token for next operations */

    // Define the URI
    $uri=$baseUrl."auth/login?login=$thisLogin&origin=bmStat";

    $api = new bmAPI();
    $api->init() ;
    $api->setOption($option);
    $api->setURI($uri);
    $api->post($thisPassword,false); //the 2nd param is set to  "false" because $password is not json encoded, otherwise set it to "true"
    $api->setPhpResponse() ;
    $token = $api->getResponse()['authKey'];
    $api->close() ; //Please close it.


    $thisArray = array() ;
    if(!empty($token)) {
        $uri=$baseUrl."auth";

        $api = new bmAPI();
        $api->init() ;
        $api->setOption($option); 
        $api->setURI($uri);
        $api->setHeaderKey($token); //Here we set the token we've got above in the request Header
        $api->setPhpResponse() ;
        $allAboutYou = $api->getResponse() ;
        $api->close() ;


        if (in_array('admin',$allAboutYou['roles']))
            $thisPerms = 'admin' ;

        $thisDomainName  = $allAboutYou['domainUid'];
        $thisDisplayName = $allAboutYou['displayName'];

        $thisArray['token']       = "$token" ;
        $thisArray['login']       = "$thisLogin" ;
        $thisArray['password']    = "$thisPassword" ;
        $thisArray['displayName'] = "$thisDisplayName" ;
        $thisArray['domainName']  = "$thisDomainName" ;
        $thisArray['perms']       = "$thisPerms" ;

    
    };


    return $thisArray ;


}

function getAllDomain() {

    require_once("/usr/share/bm-stats/www/class/bmAPI/bmAPI.php");

    $bmIni = '/etc/bm/bm.ini';
    $dataBmIni = parse_ini_file($bmIni);

    $baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/" ;

    /* A set of options used by the cURL client  */
    $option = array(
                            CURLOPT_VERBOSE        => FALSE,
                            CURLOPT_RETURNTRANSFER => TRUE,
                            CURLOPT_SSL_VERIFYPEER => FALSE,
                            CURLOPT_SSL_VERIFYHOST => 0,
                            CURLOPT_CONNECTTIMEOUT => 5,
                            CURLOPT_TIMEOUT        => 5,
                          );

    /* Get a token for next operations */

    // Define the URI
    $uri=$baseUrl."domains";

    $api = new bmAPI();
    $api->init() ;
    $api->setOption($option);
    $api->setURI($uri);
    $api->setHeaderKey($_SESSION['token']); //Here we set the token we've got above in the request Header
    $api->setPhpResponse(); 
    $allDomains = $api->getResponse() ;
    $api->close() ;


    foreach($allDomains as $domain) {
            $thisDomainId   = $domain['internalId'] ;
            $thisDomainName = $domain['uid'];

            $thisList[$thisDomainId] = "$thisDomainName" ;
    }    
    
    ksort($thisList) ;
    return $thisList ;
}

/**
the domain is get from session values

*/

function listAllUserForThisDomain() {

    require_once("/usr/share/bm-stats/www/class/bmAPI/bmAPI.php");

    $bmIni = '/etc/bm/bm.ini';
    $dataBmIni = parse_ini_file($bmIni);

    $baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/" ;

    /* A set of options used by the cURL client  */
    $option = array(
                            CURLOPT_VERBOSE        => FALSE,
                            CURLOPT_RETURNTRANSFER => TRUE,
                            CURLOPT_SSL_VERIFYPEER => FALSE,
                            CURLOPT_SSL_VERIFYHOST => 0,
                            CURLOPT_CONNECTTIMEOUT => 5,
                            CURLOPT_TIMEOUT        => 5,
                          );

    /* Get a token for next operations */

    // Define the URI
    $uri=$baseUrl."mailboxes/".$_SESSION['domainName']."/_list";

    $api = new bmAPI();
    $api->init() ;
    $api->setOption($option);
    $api->setURI($uri);
    $api->setHeaderKey($_SESSION['token']); //Here we set the token we've got above in the request Header
    $api->setPhpResponse(); 
    $allEntries = $api->getResponse() ;
    $api->close() ;


    foreach($allEntries as $entry) {
        if(!preg_match("/^_.*/i",$entry['value']['name']))
            $thisList[] =  $entry['value']['name'];
    }
    
    
    sort($thisList) ;

    return array_unique($thisList) ;
 
}



function checkToken() {

    require_once("/usr/share/bm-stats/www/class/bmAPI/bmAPI.php");

    $bmIni = '/etc/bm/bm.ini';
    $dataBmIni = parse_ini_file($bmIni);

    $baseUrl=$dataBmIni['external-protocol']."://".$dataBmIni['external-url']."/api/" ;

    /* A set of options used by the cURL client  */
    $option = array(
                            CURLOPT_VERBOSE        => FALSE,
                            CURLOPT_RETURNTRANSFER => TRUE,
                            CURLOPT_SSL_VERIFYPEER => FALSE,
                            CURLOPT_SSL_VERIFYHOST => 0,
                            CURLOPT_CONNECTTIMEOUT => 5,
                            CURLOPT_TIMEOUT        => 5,
                          );

	
    // Define the URI
    $uri=$baseUrl."auth/ping";

    $api = new bmAPI();
    $api->init() ;
    $api->setOption($option);
    $api->setURI($uri);
    $api->setHeaderKey($_SESSION['token']); //Here we set the token we've got above in the request Header
    $api->setPhpResponse();
    $check = $api->getResponse() ;
    $api->close() ;
	
    if(!empty($check)) {

	// Define the URI
    	$uri=$baseUrl."auth/login?login=".$_SESSION['login']."&origin=bmStat";

    	$api = new bmAPI();
    	$api->init() ;
    	$api->setOption($option);
    	$api->setURI($uri);
    	$api->post($_SESSION['password'],false); //the 2nd param is set to  "false" because $password is not json encoded, otherwise set it to "true"
    	$api->setPhpResponse() ;
    	$_SESSION['token'] = $api->getResponse()['authKey'];
    	$api->close() ; //Please close it.

    }
}


?>
